;TIP940.LSP: IDXYZ.LSP   Label a Point   (c)1994, John R. Ricker

; Example Run    :
;
; Snap Mode [E]nd [M]id [I]nt [C]ent [NE]ar [NO]de ? <I>: NE
; Enter Desired Text Size ? :
; ID format to use [ X Y Z XY XZ YZ YX ZX ZY XYZ XZY YXZ YZX ZXY ZYX ]: ZYX
; UNIT type to use [S]cientific [D]ec [A]rchitect [E]ng [F]ract : D
; Enter number of Decimal Places to use ? < 2 > : 2
; Please pick POINT to ID and lable with TEXT...  <do so>
;   ************* continues until carriage return is hit ***************
; Please pick POINT to ID and lable with TEXT...  <do so>
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(princ "\Loading IDXYZ Please Wait..")

(defun C:IDXYZ ( / TYP PT VAL$ OS ANS TXTSZ XYZ$ DP UT)
   (setvar "CMDECHO" 0)
   (setq OS (getvar "OSMODE")
      TYP
      (strcase
         (getstring "\nSnap Mode [E]nd [M]id [I]nt [C]ent [NE]ar [NO]de ? <I>: ")
      )                                            ; close strcase
   )                                              ; end setq
   ;
   ; set the OSMODE
   ;
   (cond ((= TYP "")  (setq TYP 32))
      ((= TYP "I") (setq TYP 32))
      ((= TYP "C") (setq TYP 4))
      ((= TYP "E") (setq TYP 1))
      ((= TYP "M") (setq TYP 2))
      ((= TYP "NE")(setq TYP 512))
      ((= TYP "NO")(setq TYP 8))
   )                                              ; end cond
   ;
   ; set the OSMODE
   ;
   (setvar "OSMODE" TYP)
   ;
   ; get the text size to use
   ;
   (setq TXTSZ
   (getreal "\n Enter Desired Text Size ? : "))
   ;
   ; get the point combination to use
   ;
   (initget 1 "X Y Z XY XZ YZ YX ZX ZY XYZ XZY YXZ YZX ZXY ZYX")
   (setq XYZ$ (getkword
   "\nID format to use [ X Y Z XY XZ YZ YX ZX ZY XYZ XZY YXZ YZX ZXY ZYX ] : "))
   ;
   ; get the unit type to display
   ;
   (initget 1 "S D E A F")
   (setq UT
      (getkword
   "\nUNIT type to use [S]cientific [D]ec [A]rchitect [E]ng [F]ract : "))
   (cond ((= UT "S")(setq UT 1))
      ((= UT "D")(setq UT 2))
      ((= UT "E")(setq UT 3))
      ((= UT "A")(setq UT 4))
      ((= UT "F")(setq UT 5))
   )                                              ; end cond
   ;
   ; get the number of decimal places to use
   ;
   (setq DP
   (getint "\nEnter number of Decimal Places to use ? < 2 > : "))
   (if (or (= DP "")(= DP nil))(setq DP 2))
   ;
   ; get insertion point first time in...
   ;
   (setq PT
   (getpoint "\n Please pick POINT to ID and lable with TEXT... "))
   (while PT
      (cond ((= XYZ$ "X")(setq VAL$  (rtos (car   PT) UT DP)))
         ((= XYZ$ "Y")(setq VAL$  (rtos (cadr  PT) UT DP)))
         ((= XYZ$ "Z")(setq VAL$  (rtos (caddr PT) UT DP)))
         ((= XYZ$ "XY")(setq VAL$ (strcat(rtos (car PT) UT DP) " , "
         (rtos (cadr PT) UT DP))))
         ((= XYZ$ "XZ")(setq VAL$ (strcat(rtos (car PT) UT DP) " , "
         (rtos (caddr PT) UT DP))))
         ((= XYZ$ "YZ")(setq VAL$ (strcat(rtos (cadr PT) UT DP) " , "
         (rtos (caddr PT) UT DP))))
         ((= XYZ$ "YX")(setq VAL$ (strcat(rtos (cadr PT) UT DP) " , "
         (rtos (car PT) UT DP))))
         ((= XYZ$ "ZX")(setq VAL$ (strcat(rtos (caddr PT) UT DP) " , "
         (rtos (car PT) UT DP))))
         ((= XYZ$ "ZY")(setq VAL$ (strcat(rtos (caddr PT) UT DP) " , "
         (rtos (cadr PT) UT DP))))
         ((= XYZ$ "XYZ")(setq VAL$ (strcat(rtos (car PT) UT DP) " , "
                  (rtos (cadr PT) UT DP) " , "
         (rtos (caddr PT) UT DP))))
         ((= XYZ$ "XZY")(setq VAL$ (strcat(rtos (car PT) UT DP) " , "
                  (rtos (caddr PT) UT DP) " , "
         (rtos (cadr PT) UT DP))))
         ((= XYZ$ "YXZ")(setq VAL$ (strcat(rtos (cadr PT) UT DP) " , "
                  (rtos (car PT) UT DP) " , "
         (rtos (caddr PT) UT DP))))
         ((= XYZ$ "YZX")(setq VAL$ (strcat(rtos (cadr PT) UT DP) " , "
                  (rtos (caddr PT) UT DP) " , "
         (rtos (car PT) UT DP))))
         ((= XYZ$ "ZXY")(setq VAL$ (strcat(rtos (caddr PT) UT DP) " , "
                  (rtos (car PT) UT DP) " , "
         (rtos (cadr PT) UT DP))))
         ((= XYZ$ "ZYX")(setq VAL$ (strcat(rtos (caddr PT) UT DP) " , "
                  (rtos (cadr PT) UT DP) " , "
         (rtos (car PT) UT DP))))
      )                                            ; end cond
      (command "TEXT" PT TXTSZ "" VAL$)
      ; get insertion point while in loop
      (setq PT
      (getpoint "\n Please pick POINT to ID and lable with TEXT... "))
   )                                              ; end while
   ;
   ; reset OSMODE
   ;
   (setvar "OSMODE" OS)
   (terpri)
)                                                ; end defun
(princ "IDXYZ Loaded.... Command = IDXYZ \n")
(princ); end idxyz.lsp

