; DDIMEDIT.LSP: routine to edit Dimension text in a PDB
; Version 1.0  1 Oct 93  by Mark Middlebrook
; Requires DDIMEDIT.DCL

(defun C:DDIMEDIT ( / diment dimtxtold dcl_id dimtxtnew)
   (setq diment (car (entsel "\nSelect a dimension: "))
         dimtxtold (cdr (assoc 1 (entget diment)))
   )
   (setq dcl_id (load_dialog "ddimedit.dcl"))
   (if (not (new_dialog "dim_edit" dcl_id)) (exit))
   (set_tile "dim_text" dimtxtold)
   (action_tile "dim_text" "(setq dimtxtnew $value)" )
   (action_tile "accept" "(done_dialog 1)" )
   (if (equal (start_dialog) 1)
      (entmod (list (cons -1 diment) (cons 1 dimtxtnew)))
   )
   (unload_dialog dcl_id)
   (princ)
)
(princ "\nDDIMEDIT.LSP loaded. DDIMEDIT runs it.")
(princ)
