; TIP1004A.LSP: WS.LSP   Draw Waterstop   (c)1994, Andrew Sloss

(DEFUN C:WS (/ LA1 OSMODE1 ORTHO1 PT1 RUN PT2 D1 A1 A1A D1B PT1B PT1A A2 D2
               PT3 PT4 PT5 PT6 PT7 PT8 PT9 PT10 PT11 PT12 PT13)
 (initerr)
 (setq prgmod (getmode '("CLAYER" "ORTHOMODE" "OSMODE" "SNAPANG")))
 (setvar "ORTHOMODE" 0)
 (if (not (tblsearch "LAYER" "JOINT"))
  (command "LAYER" "N" "JOINT" "C" "R" "JOINT" "");;;;;;********************
 );end if
 (if (not (tblsearch "LAYER" "WSTOP"))
  (command "LAYER" "N" "WSTOP" "C" "G" "WSTOP" "");;;;;;********************
 );end if
 (setq
  aslope (if ASLOPE "2" "1")
  aslope
  (=
   2
   (ukword 1 "1 2" "Enter <1> for straight key - <2> for sloped key" aslope)
  )
  prom
  (strcat
   "\nPick joint start pt. on one side of wall using correct osnap"
   " or return to exit: "
 ))
 (initget 1)
 (while (setq PT1 (GETPOINT prom))
  (setvar "OSMODE" 128)
  (initget 1)
  (setq PT2 (getpoint PT1 "\nPick pt. on opp. side of wall: "))
  (setvar "OSMODE" 0)
  (setq
   D1 (distance PT1 PT2)
   A1 (angle PT1 PT2)
   A1A (+ (/ PI 2) A1)
   D1B (/ D1 2.0)
   PT1B (polar PT1 A1 D1B)
  )
  (grdraw PT1 PT2 -1 1)
  (setvar "SNAPANG" A1A)
  (setvar "ORTHOMODE" 1)
  (initget 1)
  (setq PT1A (getpoint PT1B "\nPick side of joint for waterstop: "))
  (setvar "SNAPANG" 0)
  (setvar "ORTHOMODE" 0)
  (redraw)
  (setq A2 (angle PT1B PT1A))
  (if (< D1 24.0)
   (setq
    D2 (/ D1 3.0)
    PT3 (polar PT1 A1 D2)
    PT4 (polar PT3 A2 2.0)
    PT5 (polar PT4 A1 D2)
    PT4 (if aslope (polar PT4 A1 0.50) pt4)
    PT5 (if aslope (polar PT5 A1 -0.50) pt5)
    D2A (if aslope (/ (distance PT4 PT5) 2.0) d2a)
    PT6 (polar PT3 A1 D2)
    PT7 (if ASLOPE (polar PT4 A1 D2A) (polar PT4 A1 (/ D2 2.0)))
    PT8 (polar PT7 (+ A1 (/ PI 2)) 3.0)
    PT9 (polar PT7 (- A1 (/ PI 2)) 3.0)
   )
   (setq
    D2 (/ (- D1 8.0) 3.0)
    PT3 (polar PT1 A1 D2)
    PT4 (polar PT3 A2 2.0)
    PT5 (polar PT4 A1 4.0)
    PT4 (if aslope (polar PT4 A1 0.50) pt4)
    PT5 (if aslope (polar PT5 (+ A1 pi) 0.50) pt5)
    PT6 (polar PT3 A1 4.0)
    PT7 (polar PT6 A1 D2)
    PT8 (polar PT7 A2 2.0)
    PT9 (polar PT8 A1 4.0)
    PT8 (if aslope (polar PT8 A1 0.50) pt8)
    PT9 (if aslope (polar PT9 A1 -0.50) pt9)
    PT10 (polar PT7 A1 4.0)
  ));end if
  (command
   "LAYER" "S" "JOINT" ""
   "PLINE" pt1 "w" "0" "0" PT3 PT4 PT5 PT6
  )
  (if (< d1 24.0) (command pt7 pt8 pt9 pt10))
  (command
   pt2 ""
   "LAYER" "S" "WSTOP" ""
  )
  (if (< D1 24.0)
   (command "pline" pt8 pt9 "") 
   (progn
    (setvar "OSMODE" 2)
    (initget 1)
    (setq PT11 (getpoint "\nPick key with waterstop: "))
    (setvar "OSMODE" 0)
    (setq
     PT12 (polar PT11 (+ A1 (/ PI 2.0)) 3.0)
     PT13 (polar PT11 (- A1 (/ PI 2.0)) 3.0)
    )
    (command "pline" PT12 PT13 "")
  ));end if
  (initget 1)
 );end while
 (setmode prgmod)
 (princ)
); end ws.lsp

(princ)
