; TIP954.LSP:  RESPACE.LSP   Align Text   (c)1994, Jonathan C. Pruett

(setq HORIZON 3)

(defun c:RESPACE (/ A Q B X Y D N T GO) 

   (defun newerr (s)                     
      (setq *error* olderr olderr nil)         
      (if (/= s "bad argument type") (princ s))
      (foreach s '(A Q B X Y D N T GO) (set s nil))
      (princ)
   )

   (defun dxf (n e) (cdr (assoc n e)))

   (defun rsgo ()
      (if (null A) (setq A (entsel "\nPICK BASE LINE OF TEXT..")))
      (setq B (entget (car A)))
      (if (= "TEXT" (dxf 0 B))
         (progn
            (setq
               X (cadr (assoc 10 B))
               Y (caddr (assoc 10 B))
            )
            (if (= D nil) 
               (setq D (* (dxf 40 B) 1.55))
            )
            (while (setq N (entget (car (entsel "\n NEXT LINE..."))))
               (if (= "TEXT" (dxf 0 N))
                  (progn
                     (setq Y (- Y D)
                        V (assoc 10 N)
                        W (car v)
                     )
                     (cond
                        ((= HORIZON 1) (setq Y (caddr V)))
                        ((= HORIZON 2) (setq X (cadr V)))
                     )      
                     (setq T (append (list W) (list X) (list Y))
                        N (subst T V N)
                     )
                     (entmod N)
                  )
               )       
            )   
         )  
      )
   )

   (setq go nil d nil olderr *error* *error* newerr)      
   (cond
      ((= HORIZON 1)(princ "\n   - HORIZONTAL SPACING ONLY -"))
      ((= HORIZON 2)(princ "\n    - VERTICLE SPACING ONLY -"))
      ((= HORIZON 3)(princ "\n- HORIZONTAL & VERTICLE SPACING -"))
   )  
   (if (null (setq A (entsel"\nPICK BASE LINE OF TEXT or RETURN FOR OPTIONS..")))
      (progn
         (while (/= "" (setq Q (strcase 
            (getstring "\n(M)OVEMENT, (H)EIGHT, <EXIT> ?:> "))))
            (cond 
               ((= Q "M") 
                  (initget 1)
                  (princ "\n1. HORIZONTAL SPACING ONLY.")  
                  (princ "\n2. VERTICLE SPACING ONLY.")  
                  (setq HORIZON (getint "\n3. HORIZONTAL & VERTICLE SPACING. :> "))
               )               
               ((= Q "H") (setq D (getdist "\nDISTANCE BETWEEN LINES ?:> ")))
            )
         )
      )    
   )    
   (rsgo)
   (setq *error* olderr olderr nil)         
   (princ)
); end respace.lsp

